#!/usr/bin/perl

###########i#############################################
# Purpose: Replace all family ids and subject ids with 
#          unique integers, and write the result to 
#          new[pedfile].
#
#  syntax:               [pedfile] 
#  syntax:  ./relabel.pl  ord.ped  
# 
#########################################################

use warnings;
$pedfile = $ARGV[0];

open(IN,"$pedfile");
@PED = <IN>;
@NEWPED = @PED;
close(IN);

# First, compute all distinct family ids

@allfamids = ();
@record = split(" ", $PED[0]);        # init @allfamids by entering 
push( @allfamids, $record[0] );       # the family id of the 1st person
for($i=1; $i<scalar(@PED); $i++)      # then, for all other individuals 
{
  @record = split(" ", $PED[$i]);
  $target = $record[0];               # get that person's family id
  $flag = 1;                          # assume that this famid is distinct
  foreach $j (@allfamids)
  {
    if( $target eq $j ){ $flag = 0; } # if not distinct
  }
  if( $flag ){ push( @allfamids, $target ); }
}

# Second, relabel the subject ids of @PED

$subid = 1;
for($i=0; $i<scalar(@PED); $i++)      # for ea person in @PED
{
  @record  = split(" ", $PED[$i]);
  $subx = $record[1];
  $famx = $record[0];

  for($j=0; $j<scalar(@NEWPED); $j++) # find and change ea instance in @NEWPED 
  {
    @record = split(" ", $NEWPED[$j]);
    @newrecord = @record;             # initialize @newrecord
    if( $famx eq $record[0])          # the family of this subject was found
    {
      if( $subx eq $record[1] )       # in this instance, the subject is an offspring
      {
        $newrecord[1] = $subid;
      }
      if( $subx eq $record[2] )       # in this instance, the subject is a father
      {
        $newrecord[2] = $subid;
      }
      if( $subx eq $record[3] )       # in this instance, the subject is a mother 
      {
        $newrecord[3] = $subid;
      }
      $NEWPED[$j] = join(" ",@newrecord)."\n"; 
    } 
  }
  $subid++;
}

# Third, relabel the famids of @PED

for($i=0; $i<scalar(@NEWPED); $i++)
{
  @record = split(" ", $NEWPED[$i]);

  $k = 0;
  foreach $j (@allfamids)                  # find the new family id
  {
    $k++;
    if( $record[0] eq $j ){ $findx = $k; } # the new fam ids will be 1-indexed
  }

  $record[0] = $findx;
  $NEWPED[$i] = join(" ", @record)."\n";
}

$newped = "new".$pedfile;
open(OUT, ">$newped");
print OUT " @NEWPED";
close(OUT);

