#!/usr/bin/perl

# use warnings;
# use strict; 

## syntax: ./haplodrop     [ped file]  [map file]   [frq file]  [rsq file]  [nreps]
## syntax: ./haplodrop.pl -p pedfile  -m mapfile  -f frqfile  -r rsqfile   -n  1

## ===================================================================
## SETUP  include headers
## ===================================================================

require 'haplosubs.ph';                        ## contains all Perl subroutines 

$pedname = $hapname = $mapname = $nreps = '';  ## intialize
$usehaps = '';                                 

use Getopt::Long;
$args = GetOptions ("p=s"   => \$pedname,      ## string
                    "m=s"   => \$mapname,      ## string
                    "f=s"   => \$frqname,      ## string
                    "r=s"   => \$rsqname,      ## string
                    "h=s"   => \$hapname,      ## string
                "usehaps"   => \$usehaps,      ## boolean 
                    "n=i"   => \$nreps,        ## integer
                 "seed=i"   => \$seed);        ## integer

srand($seed);
system("clear; rm -f Output/haplo.out");
chkpars();
$pedname  = "Inputs/" . $pedname;
$mapname  = "Inputs/" . $mapname;
if( !$usehaps ) 
{
  $frqname  = "Inputs/" . $frqname;
  $rsqname  = "Inputs/" . $rsqname;
}
else { $hapname = "Inputs/" . $hapname; }

open(OUT,">>Output/haplo.out");

prpars();    ## remind me what args were passed to Haplodrop

getinputs(); ## read in the observed pedigree, mapfile, etc.

genconfs();  ## generate the complete multilocus genotypic configuration k-times 
             ##
             ## this subrountine also calls the following:
             ##    - sampdips()
             ##    - seghaps()
             ##    - mkoutped()
             ##    - analyze()

print "\n\n All simulated pedigrees are in Output/haplo.out \n";
print "\n THANK YOU for using $version \n\n";

# print @allhaps; print "\n";
# foreach $i (@obsped){ print $i."\n"; } print "\n";
# print @map; print "\n";

close(OUT);

## END hapdrop
## ===========

