## Header file for main program

## Note: 
##
##     The paternal haplotype ALWAYS precedes the maternal haplotype 
##     in the hash: diplos (i.e. if the pathap is the ith element, then 
##     the mathap is the (i+1)th element).
##
##     For now, we are assuming that the observed pedigree has 
##     been given in chronological order, so that parents are 
##     ALWAYS listed before their offspring.

## ===================
## Initializations
## ===================

$seed = 62070;                  ## the default seed 
$version = "Haplodrop-v0.2";
@allhaps = ();

## ===================
## All Subroutines
## ===================

require "Utils/analyze.sub";    ## analyze a multilocus geno config and get stats
require "Utils/chkpars.sub";    ## perform minimal checking for the validity of input parameters
require "Utils/genconfs.sub";   ## generates multilocus geno configs repeatedly
require "Utils/genhap.sub";     ## generate a random nsite haplotype  
require "Utils/getinputs.sub";  ## read in: Caleb data and the observed pedigree 
require "Utils/haldane.sub";    ## convert map distances to recombination fractions 
require "Utils/mkoutped.sub";   ## creating the multilocus genos from the diplos
require "Utils/propts.sub";     ## print to the screen, options selected by the user 
require "Utils/prpars.sub";     ## print the haplodrop command-line args
require "Utils/sampdips.sub";   ## sample diplotypes
require "Utils/seghaps.sub";    ## recombine and segregate founder haplotypes

