#!/bin/bash

usage() {
        echo "Usage: $1 [-p Ped file] [-d Dat file] [-m Map file]" >&2
        echo "       [-r rldt value] [-n nsubs] [-k nskips]" >&2
        echo "       [-p para] [-o modfile] [-s seed] [-t tasksize]" >&2
        echo "       [-?]" >&2
        exit 2
}

# Defaults
Peds=
Dats=
Maps=
RLDT=
NSUBS=2
NSKIPS=50
PARA=
MOD=
SEED=6310
TaskSize="tiny"


program=$(basename $0)
while getopts "p:d:m:r:n:k:a:o:s:t:?" name; do
        case "$name" in
                p) Peds=$OPTARG;;
                d) Dats=$OPTARG;;
                m) Maps=$OPTARG;;
                r) RLDT=$OPTARG;;
                n) NSUBS=$OPTARG;;
                k) NSKIPS=$OPTARG;;
                a) PARA=$OPTARG;;
                o) MOD=$OPTARG;;
                s) SEED=$OPTARG;;
                t) TaskSize=$OPTARG;;
                ?) usage $program MOAR;;
                *) usage $program;;
        esac
done


if [[ -z "$Peds" ]]; then
        echo "Ped file should be specifed under Peds/"
         usage $program;
fi
if [[ -z "$Dats" ]]; then
        echo "Dat file should be specifed under Datss/"
         usage $program;
fi
if [[ -z "$Maps" ]]; then
        echo "Map file should be specifed under Maps/"
         usage $program;
fi
if [[ -z "$RLDT" ]]; then
        echo "RLDT should be specifed under"
         usage $program;
fi
if [[ -z "$PARA" ]]; then
        echo "PARA file should be specifed under Mods/"
         usage $program;
fi
if [[ -z "$MOD" ]]; then
        echo "Mod file should be specifed under Mods/"
         usage $program;
fi


ROOT_PATH=$(head -1 ./br.hosts | awk '{print $2}' | awk -F\; '{ print $4}' )


./preProcessing.sh $Peds $TaskSize $NSUBS

nodes=$(wc -l ./br.hosts | awk '{print $1}')
if [ $nodes -gt 1 ]
then

        nodes=$(( nodes - 1))
        hosts=$(tail -$nodes ./br.hosts | awk '{print $1}';)
        for i in $hosts
        do
                HOME=$(cat ./br.hosts | grep $i | awk '{print $2}' | awk -F\; '{print $1}')
                HOME=${HOME/bin.sh/preProcessing.sh}
                DIR=${HOME/preProcessing.sh/}
		BRHOME=${DIR/Bashreduce/}
		scp ../Peds/$Peds $i:$BRHOME/Peds;
                ssh $i "cd "$DIR";"$HOME" "$Peds" "$TaskSize" "$NSUBS;
        done

fi

./mybr -t $ROOT_PATH/Bashreduce/tmp -p 1 -m $ROOT_PATH"/Bashreduce/bin.sh 1000 1 "$ROOT_PATH -P $Peds -s $Dats -N $Maps -R $RLDT -n $NSKIPS -a $PARA -O $MOD -B $SEED -T $TaskSize < s-list


count=$( wc -l list | awk '{print $1}')

if [ $count -gt 999 ]
then
	cp ./br.hosts $ROOT_PATH/Bashreduce/br.hosts2
	sed -i 's/bin/alod/g' $ROOT_PATH/Bashreduce/br.hosts2
	cp  $ROOT_PATH/Bashreduce/br.hosts2 ./br.hosts
	./mybr -t $ROOT_PATH/Bashreduce/tmp -p 12 -m $ROOT_PATH"/Bashreduce/alod.sh 1000 $1 "$ROOT_PATH < list 
	 cp ./br.hosts $ROOT_PATH/Bashreduce/br.hosts2
	sed -i 's/alod/bin/g'  $ROOT_PATH/Bashreduce/br.hosts2
	 cp  $ROOT_PATH/Bashreduce/br.hosts2 ./br.hosts
else


nodes=$(wc -l ./br.hosts | awk '{print $1}')

if [ $nodes -gt 1 ]
then

        nodes=$(( nodes - 1))
        hosts=$(tail -$nodes ./br.hosts | awk '{print $1}';)
	echo $HOME
	echo $ROOT_PATH
        for i in $hosts
        do
                HOME=$(cat ./br.hosts | grep $i | awk '{print $2}' | awk -F\; '{print $1}')
                HOME=${HOME/\/Bashreduce\/bin.sh/}
                DIR=${HOME/preProcessing.sh/}
                scp -r $i:$HOME/Results/Test/* $ROOT_PATH/Results/Test/;
        done

fi


  ./alod.py list $ROOT_PATH 

fi



./meta.py $ROOT_PATH

while read line
 do 
	rm ../Peds/$line
 done < rmlist
