/*****************************************************/
/*                                                   */
/*  This is the header file for ALL globals          */
/*                                                   */
/*****************************************************/

/* Some standard includes used by all main progs     */ 
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>

#define EPSI 0.001   /* Fudge factor so that         */
                     /* the LD measure is well-      */
                     /* defined for monomorphic SNPs */

#define NEMit 50     /* Number of EM iterations      */

#define RFACTOR  0.3 /* RFACTOR is used to create    */
                     /* SNP-specific LD thresholds   */
                     /* subject to [0,1] boundary    */
                     /* constraints.  RFACTOR=0      */
                     /* implies that all SNPs have   */
                     /* the same worth (i.e. the     */
                     /* LD threshold).               */

#define BOOT 0       /* Number of bootstrap samples  */

#define SEED 62070   /* SEED = 0 ---> random         */

#define TIMEOUT 100  /* The maximum number of time   */
                     /* that LDsubsample should look */
                     /* for a starting SNP before    */
                     /* giving up                    */

int** PED;           /* The input merlin pedfile     */

char*** DAT;         /* The input merlin datfile     */

