/**********************************************************/
/*                                                        */
/*  This is the header file for ldsubsample.c             */
/*                                                        */
/**********************************************************/

/* Define the structure for the linked list of snps       */
struct node
{
  int snpindx;           /* index of the snp relative to  */
                         /* the complete set of snps      */

  float ldmetricr, ldmetricl;
  struct node* nxtrightptr;
  struct node* nxtleftptr;
};

typedef struct node Node;
typedef Node* Nodeptr;

void readped( char*, int* );     
                         /* get a matrix of ints          */

void readdat( char*, int );  
                         /* get a matrix of strings       */

void writedat( char*, int, Nodeptr, int );
                         /* write new merlin dat file     */

void freemem( int* );
                         /* free memory allocated for     */
                         /* global variables              */
void pr_opts();    
                         /* prints program options to     */
                         /* stderr                        */

void errchk( char** );
                         /* check for command-line        */
                         /* argument errors               */

void pr_sumstats( int*, char**, float, int, int );
                         /* print summary statistics out  */
                         /* to a file                     */

void pushright( Nodeptr*, int, float );
                         /* push an integer onto the      */
                         /* rightmost end of the list     */

void pushleft( Nodeptr*, int, float );
                         /* push an integer onto the      */
                         /* leftmost end of the list      */

void delete( Nodeptr* ); /* free all nodes in list        */

void pr_list( Nodeptr );
                         /* print all nodes in list       */

int getfirstsnp( int*, float );
                         /* get the first (random) snp of */
                         /* a given subset                */

