#include <stdlib.h>
#include <stdio.h>
#include "../Headers/globs.h"
#include "../Headers/ldinfo.h"

/************************************************************/
/* Print the list of arguments used in the current analysis */
/************************************************************/

void pr_args ( char** args, int nwsd )
{
  printf("  Analysis parameters : %s %s %d \n", args[1], args[2], atoi(args[3]));
}


/********************************************************/
/* Read in a retangular array of integers, without      */
/* specifying the dimensions in advance.  Modify by     */
/* reference the value of dim[].  Return the matrix in  */
/* a one-indexed arrary.                                */
/********************************************************/

void readped( char* file, int* dim )
{
  int nentries, c, i, j, r, x;
  FILE* fptr;
  
  r = c = nentries = 0;
  if( (fptr = fopen(file,"r")) == NULL )
  {
    fprintf(stderr,"The file : %s was not found! \n", file);
    exit(8);
  }
  else
  {
    while( !feof(fptr) )  /* count rows first */
    {
      if( (int)fgetc(fptr) == 10 ) r++;
    }

    rewind(fptr);
    while( !feof(fptr) ) /* count cols second */
    {
      fscanf(fptr,"%d",&x); 
      nentries++;
    }
    c = nentries / r;
 
    rewind(fptr);
    PED = malloc( (r+1) * sizeof( int* ) );
    for( i=0; i<=r; i++) 
      PED[i] = malloc( (c+1) * sizeof( int ));

    for( i=0; i<=r; i++)     /* read the pedfile,    */
      for( j=0; j<=c; j++)   /* which is one-indexed */
      {
        if( i==0 || j==0 ) PED[i][j] = 0;
        else fscanf(fptr, "%d", PED[i] + j);
      } 
  }
  
  dim[0] = r;
  dim[1] = nentries / r;

  //printf("               Read : %d integers from a [%d x %d] data matrix. \n", (r * c), r, c);
  fclose( fptr );
}

