/* This source samples a random SNP from the orignial subset */
/* of densely spaced SNPs                                    */
                          
#include <stdlib.h>
#include <stdio.h>
#include "../Headers/ldsubsample.h"
#include "../Headers/globs.h"
#include "../Headers/ldlib.h"


/**************************************************/
/* Find the first SNP in the subset by sampling   */
/* SNPs at random and choosing the first SNP with */
/* heterozygosity greater than or equal to a      */
/* preset threshold                               */
/**************************************************/

int getfirstsnp( int* dim, float hetLB )
{
  int i, firstsnp=0, ntrys=0, u, nsnps;
  float hetero; 

  nsnps = (dim[1] - 6)/2;
  while( !firstsnp && ntrys <= TIMEOUT )
  {
    ntrys++;
    u = (rand() % nsnps) + 1;        /* sample U~[1,nsnps] */
    hetero = comphet( u, dim[0] ); 
    if( hetero >= hetLB ) firstsnp = u;
  }

  if( ntrys > TIMEOUT)
  {
    printf("Error : More than %3d tries w/o finding a starting SNP. \n", TIMEOUT);
    exit(8);
  }

  return(firstsnp);
}
