## Header file for main program: EAGLET
## Since order does not matter, subroutines are 
## given in alphabetical order within class

## ===================
## Generic subroutines
## ===================

require "Utils/GenLib/extract.sub";    ## create input files for a subsample
require "Utils/GenLib/import.sub";     ## read in data
require "Utils/GenLib/procfx.sub";     ## compute summary stats for nxm matrix
require "Utils/GenLib/sample_wr.sub";  ## sample a vector with replacement


## ===============================
## Specific subroutines for EAGLET 
## ===============================

require "Utils/SpecLib/alod.sub";       ## compute the ALOD 
require "Utils/SpecLib/chkpars.sub";    ## chk pars for consistency 
require "Utils/SpecLib/getmmls.sub";    ## extract the dom and rec lods to compute the mmls-c
require "Utils/SpecLib/getnplod.sub";   ## extract nonparametric lod score curve 
require "Utils/SpecLib/getplod.sub";    ## extract parametric lod score curve 
require "Utils/SpecLib/propts.sub";     ## print options
require "Utils/SpecLib/prpars.sub";     ## print parameters in effect

